# da bismo mogli da pravimo gui u Pythonu
# potrebno je da ukljucimo biblioteku Tkinter
from Tkinter import *

# prazan prozor pravimo pomocu funkcije
# Tk() iz biblioteke Tkinter
window = Tk()
# postavljamo naslov na prozor
window.title('Buttons and entries')
# dozvoljavamo promenu velicine prozora
# po obe ose
window.resizable(1,1)

# definisemo klasu koja ce nam omoguciti
# da rasporedimo labele na jednostavan nacin
class Application(Frame):
	
	# kreiramo konstruktor
	# prvi argument je referenca na samog sebe
	# drugi argument je referenca na prozor nad kojim
	# zelimo da napravimo frejm
	def __init__(self, master):
		# kreiramo Frame
		Frame.__init__(self, master)
		# crtamo objekte na formi
		self.createWidgets()
	
	#definisemo funkciju koja brise sadrzaj sa textBoxa
	def clearText(self):
		# brisemo tekst sa text boxa
		self.textBox.delete(0, END)
		# upisujemo poruku korisniku da je akcija izvrsena
		self.textBox.insert(0, 'Cleared')
		# stampamo log na konzoli
		print('Text box cleared')
	
	# definisemo funkciju koja cita sadrzaj sa textBoxa
	def readText(self):
		# citamo sadrzaj i pamtimo ga u promenljivoj s
		s = self.textBox.get()
		# stamapamo log na konzoli
		print('Text box: %s'%(s))
		
	
	def createWidgets(self):
		# kreiramo text box pomocu koga cemo da unosimo tekst
		# komponenta za unos u tkinter-u se zove Entry
		self.textBox = Entry(self, 
							 font=("Helvetica", 16), 
							 borderwidth=0, 
							 relief=RAISED,
							 justify=CENTER
							)
		# upisujemo pocetni tekst na komponentu
		self.textBox.insert(0, "Izmenite tekst")
		# postavljamo komponentu na formu
		self.textBox.grid(row = 0, column = 0, columnspan = 2)
		
		# kreiramo dugme za brisanje sadrzaja sa textboxa
		# jedan nacin da se podesi akcija prilikom
		# klika na dugme je polje command
		# da bi se akcija podesila dovoljno je da 
		# dodelimo lambda izraz koji opisuje zeljenu akciju
		self.clearButton = Button(self, 
								  font=("Helvetica",11), 
								  text="Clear", 
								  borderwidth=0, 
								  command = lambda: self.clearText()
								 )
		# postavljamo dugme na formu
		self.clearButton.grid(row = 1, column = 0, columnspan = 1)
		
		# kreiramo dugme za citanje sadrzaja sa textboxa
		self.readButton = Button(self, 
								  font=("Helvetica",11), 
								  text="Read", 
								  borderwidth=0, 
								  command = lambda: self.readText()
								 )
		# postavljamo dugme na formu
		self.readButton.grid(row = 1, column = 1, columnspan = 1)

# crtamo komponente na prozoru
# i postavljamo menadzer rasporedjivanja
# (layout manager) na formi
# izabrani menadzer je grid, tj. mreza
app = Application(window).grid()
# da bismo korisniku prikazali kreirani
# prozor moramo da pozovemo metod mainloop
window.mainloop()
