# da bismo mogli da pravimo gui u Pythonu
# potrebno je da ukljucimo biblioteku Tkinter
from Tkinter import *

# prazan prozor pravimo pomocu funkcije
# Tk() iz biblioteke Tkinter
window = Tk()
# postavljamo naslov na prozor
window.title('Buttons and entries')
# dozvoljavamo promenu velicine prozora
# po obe ose
window.resizable(1,1)

# definisemo klasu koja ce nam omoguciti
# da rasporedimo labele na jednostavan nacin
class Application(Frame):
	
	# kreiramo konstruktor
	# prvi argument je referenca na samog sebe
	# drugi argument je referenca na prozor nad kojim
	# zelimo da napravimo frejm
	def __init__(self, master):
		# kreiramo Frame
		Frame.__init__(self, master)
		# crtamo objekte na formi
		self.createWidgets()
	
	# definisemo event handler koji stampa tekst sa
	# dugmeta na koje je korisnik kliknuo
	def buttonName(self, event):
		# dohvatamo referencu na dugme na koje
		# je korisnik kliknuo
		b = event.widget
		# pomocu funkcije cget citamo text sa dugmeta
		# ako nam treba bilo koji drugi parametar, treba samo
		# navesti njegovo ime
		t = b.cget('text')
		
		# stampamo procitani tekst u konzoli
		print('Kliknuto je dugme: %s'%(t))
		
		# pomocu funkcije config menjamo boju dugmeta
		# na isti nacin menja se i bilo koji drugi parametar
		# navodjenjem imena i zeljene vrednosti
		b.config(background='red')
		
	# definisemo funkciju koja popunjava 
	# formu komponentama
	def createWidgets(self):
		# lista dugmica
		self.buttons = []
		
		# u petlji kreiramo mrezu dugmica
		for i in range(4):
			for j in range(4):
				# kreiramo dugme i pamtimo ga 
				# u listi dugmica
				self.buttons.append(Button(self, text=str(i*4+j)))
				# postavljamo dugme na formu
				self.buttons[i*4+j].grid(row = i, column = j)
				# vezujemo dugme za event handler
				# kada korisnik klikne levim tasterom misa
				# prikazace se u konzoli tekst sa dugmeta
				# levi klik misa je Button-1, srednji klik Button-2
				# a desni klik Button-3
				self.buttons[i*4+j].bind("<Button-1>", self.buttonName)
				
				# prednost vezivanja event handlera u odnosu na postavljanje 
				# akcija pomocu command polja se ogleda u tome sto u svakom
				# trenutku znamo koje dugme je izazvalo dogadjaj i na taj nacin
				# mozemo da imamo samo jedan event handler za citavu
				# klasu srodnih dogadjaja. 
				# u slucaju da koristimo command polje, morali bismo da imamo
				# po jednu funkciju za svako pojedinacno dugme, sto nezanemarljivo
				# usloznjava odrzavanje koda

# crtamo komponente na prozoru
# i postavljamo menadzer rasporedjivanja
# (layout manager) na formi
# izabrani menadzer je grid, tj. mreza
app = Application(window).grid()
# da bismo korisniku prikazali kreirani
# prozor moramo da pozovemo metod mainloop
window.mainloop()
