# da bismo mogli da pravimo gui u Pythonu
# potrebno je da ukljucimo biblioteku Tkinter
from Tkinter import *

# prazan prozor pravimo pomocu funkcije
# Tk() iz biblioteke Tkinter
calculator = Tk()
# postavljamo naslov na prozor
calculator.title('Calculator')
# dozvoljavamo promenu velicine prozora
# po obe ose
calculator.resizable(1, 1);

# definisemo klasu koja ce nam omoguciti
# da rasporedimo labele na jednostavan nacin
class Application(Frame):
	
	# kreiramo konstruktor
	# prvi argument je referenca na samog sebe
	# drugi argument je referenca na prozor nad kojim
	# zelimo da napravimo frejm
	def __init__(self, master):
		# kreiramo Frame
		Frame.__init__(self, master)
		# crtamo objekte na formi
		self.createWidgets()
	
	# funkcija menja tekst prikazan na ekranu kalkulatora
	def replaceText(self, text):
		# brisemo stari sadrzaj
		self.display.delete(0,END)
		# upisujemo novi od pocetka ekrana
		self.display.insert(0, text)
	
	# funkcija nadovezuje tekst na postojeci tekst
	# na ekranu kalkulatora
	def appendToDisplay(self, text):
		# citamo postjeci tekst sa ekrana
		self.entryText = self.display.get()
		# odredjujemo duzinu teksta
		self.textLength = len(self.entryText)
		
		# ako je na ekranu samo 0
		if self.entryText == "0":
			# upisujemo novi tekst
			self.replaceText(text)
		else:
			# u suprotnom, dodajemo novi tekst na kraj
			self.display.insert(self.textLength, text)
	
	# funkcija brise sadrzaj ekrana kalkulatora
	def clearText(self):
		self.replaceText("0")
	
	# funkcija brise jednu cifru sa ekrana
	def clearDigit(self):
		# citamo tekst sa ekrana
		self.entryText = self.display.get()
		# odredjujemo duzinu teksta
		self.textLength = len(self.entryText)
		
		# ako nije u pitanju nula i ako je tekst duzi od 1
		if self.entryText != "0" and self.textLength > 1:
			# izbacujemo poslednji upisani broj
			self.replaceText(self.entryText[:-1])
		else:
			# u suprotnom upisujemo 0 na ekran
			self.replaceText("0")
	
	# funkcija izracunava izraz zapisan na ekranu
	def calculateExpression(self):
		# citamo tekst sa ekrana
		self.expression = self.display.get()
		# procenat menjamo deljenjem sa 100
		self.expression = self.expression.replace("%", "/ 100")
		
		try:
			# pokusavamo da izracunamo izraz
			self.result = eval(self.expression);
			# ako uspemo, prikazujemo rezultat
			self.replaceText(self.result)
		except:
			# ako ne, hvatamo izuzetak i prikazujemo poruku o gresci
			messagebox.showinfo("Error", "Invalid input", icon="warning", parent=calculator)
	
	# definisemo funkciju koja popunjava 
	# formu komponentama
	def createWidgets(self):
				
		# displej
		self.display = Entry(self, font=("Helvetica", 16), borderwidth=0, 
							 relief=RAISED,justify=RIGHT)
		self.display.insert(0,"0")
		self.display.grid(row=0, column=0,columnspan=5)
		
		# prvi red		
		self.sevenButton = Button(self, font=("Helvetica",11), text="7", 
								  borderwidth=0, 
								  command = lambda: self.appendToDisplay("7")) 
		self.sevenButton.grid(row = 1, column = 0)
		
		self.eightButton = Button(self, font=("Helvetica",11), text="8", 
								  borderwidth=0, 
								  command = lambda: self.appendToDisplay("8")) 
		self.eightButton.grid(row = 1, column = 1)
		
		self.nineButton = Button(self, font=("Helvetica",11), text="9", 
								 borderwidth=0, 
								 command = lambda: self.appendToDisplay("9")) 
		self.nineButton.grid(row = 1, column = 2)
		
		self.timesButton = Button(self, font=("Helvetica",11), text="*", 
								  borderwidth=0, 
								  command = lambda: self.appendToDisplay("*")) 
		self.timesButton.grid(row = 1, column = 3)
		
		self.clearButton = Button(self, font=("Helvetica",11), text="C", 
								  borderwidth=0, 
								  command = lambda: self.clearDigit()) 
		self.clearButton.grid(row = 1, column = 4)
		
		# drugi red
		self.fourButton = Button(self, font=("Helvetica",11), text="4", 
								 borderwidth=0, 
								 command = lambda: self.appendToDisplay("4")) 
		self.fourButton.grid(row = 2, column = 0)
		
		self.fiveButton = Button(self, font=("Helvetica",11), text="5", 
								 borderwidth=0, 
								 command = lambda: self.appendToDisplay("5")) 
		self.fiveButton.grid(row = 2, column = 1)
		
		self.sixButton = Button(self, font=("Helvetica",11), text="6", 
								borderwidth=0, 
								command = lambda: self.appendToDisplay("6")) 
		self.sixButton.grid(row = 2, column = 2)
		
		self.divideButton = Button(self, font=("Helvetica",11), text="/", 
								   borderwidth=0, 
								   command = lambda: self.appendToDisplay("/")) 
		self.divideButton.grid(row = 2, column = 3)
		
		self.clearAllButton = Button(self, font=("Helvetica",11), text="CE", 
									 borderwidth=0, 
									 command = lambda: self.clearText()) 
		self.clearAllButton.grid(row = 2, column = 4)
		
		# treci red
		self.oneButton = Button(self, font=("Helvetica",11), text="1", 
								borderwidth=0, 
								command = lambda: self.appendToDisplay("1")) 
		self.oneButton.grid(row = 3, column = 0)
		
		self.twoButton = Button(self, font=("Helvetica",11), text="2", 
								borderwidth=0, 
								command = lambda: self.appendToDisplay("2")) 
		self.twoButton.grid(row = 3, column = 1)
		
		self.threeButton = Button(self, font=("Helvetica",11), text="3", 
								  borderwidth=0, 
								  command = lambda: self.appendToDisplay("3")) 
		self.threeButton.grid(row = 3, column = 2)
		
		self.minusButton = Button(self, font=("Helvetica",11), text="-", 
								  borderwidth=0, 
								  command = lambda: self.appendToDisplay("-")) 
		self.minusButton.grid(row = 3, column = 3)
		
		self.percentageButton = Button(self, font=("Helvetica",11), text="%", 
									   borderwidth=0, 
									   command = lambda: self.appendToDisplay("%")) 
		self.percentageButton.grid(row = 3, column = 4)
		
		# cetvrti red
		self.zeroButton = Button(self, font=("Helvetica",11), text="0", 
								 borderwidth=0, 
								 command = lambda: self.appendToDisplay("0")) 
		self.zeroButton.grid(row = 4, column = 0, columnspan = 2)
		
		self.dotButton = Button(self, font=("Helvetica",11), text=".", 
								borderwidth=0, 
								command = lambda: self.appendToDisplay(".")) 
		self.dotButton.grid(row = 4, column = 2)
		
		self.plusButton = Button(self, font=("Helvetica",11), text="+", 
								 borderwidth=0, 
								 command = lambda: self.appendToDisplay("+")) 
		self.plusButton.grid(row = 4, column = 3)
		
		self.equalButton = Button(self, font=("Helvetica",11), text="=", 
								  borderwidth=0, 
								  command = lambda: self.calculateExpression()) 
		self.equalButton.grid(row = 4, column = 4)
		
# crtamo komponente na prozoru
# i postavljamo menadzer rasporedjivanja
# (layout manager) na formi
# izabrani menadzer je grid, tj. mreza		
app = Application(calculator).grid()
# da bismo korisniku prikazali kreirani
# prozor moramo da pozovemo metod mainloop
calculator.mainloop()
